#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <errno.h>
#include <jni.h>
#include "gfx.h"

char *default_fn;
char *files_dir;
static JavaVM *vm= NULL;
static JNIEnv *env;
static int java_ok;

static int java_begin()
{
  int R;
  if (java_ok==1) return 0;
  if (java_ok==2) return 1;
  java_ok= 2;
  
  vm= gfx_get_javavm(); 
  if (!vm) return 1;
  R= (*vm)->AttachCurrentThread(vm, &env, NULL);
  if (R) return 1;
  java_ok= 1;
  return 0;
}

static int java_end()
{
  if (java_ok==2) return 1;
  if (java_ok==0) return 0;
  (*vm)->DetachCurrentThread(vm);
  vm= NULL;
  env= NULL;
  java_ok= 0;
  return 0;
}

static char *get_download_directory()
{
  jmethodID mid;
  jfieldID fid;
  jclass cls;
  jobject obj1,obj2,obj3;
  jboolean iscopy;
  const char *chrs;
  char *k;

#define GPTR(UU) if (!UU) goto done

  k= NULL;
  obj1= obj2= obj3= NULL;

  cls= (*env)->FindClass(env,"android/os/Environment");
  GPTR(cls);
  fid= (*env)->GetStaticFieldID(env, cls,
                   "DIRECTORY_DOWNLOADS", 
                   "Ljava/lang/String;");
  GPTR(fid);
  obj1= (*env)->GetStaticObjectField(env, cls, fid);
  GPTR(obj1);

  mid= (*env)->GetStaticMethodID(env, cls,
                    "getExternalStoragePublicDirectory",
                    "(Ljava/lang/String;)Ljava/io/File;");
  GPTR(mid);

  obj2= (*env)->CallStaticObjectMethod(env, cls, mid, obj1);
  GPTR(obj2);

  cls= (*env)->GetObjectClass(env, obj2);
  GPTR(cls);

  mid= (*env)->GetMethodID(env, cls,
                     "getAbsolutePath", 
                     "()Ljava/lang/String;");
  GPTR(mid);

  obj3= (*env)->CallObjectMethod(env, obj2, mid);
  GPTR(obj3);

  chrs= (*env)->GetStringUTFChars(env, obj3, &iscopy);
  GPTR(chrs);
  k= strdup(chrs);
  (*env)->ReleaseStringUTFChars(env, obj3,chrs);
done:
  if (obj3) (*env)->DeleteLocalRef(env, obj3);
  if (obj2) (*env)->DeleteLocalRef(env, obj2);
  if (obj1) (*env)->DeleteLocalRef(env, obj1);
#undef GPTR
  return k;
}


void android_main(void *state, size_t state_size)
{
  char buf[2000];
  if (!java_begin())
  {
    files_dir= get_download_directory();
    java_end();
  }
  if (!files_dir) files_dir= "/storage/emulated/0/Download";
  sprintf(buf,"%s/default.tar", files_dir);
  default_fn= strdup(buf);
  viewer_main();
}
